
package uoc.facturaweb.controlador;

import java.io.FileWriter;
import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import uoc.facturaweb.modelo.Cliente;
import uoc.facturaweb.modelo.Concepto;
import uoc.facturaweb.modelo.Entidad;
import uoc.facturaweb.modelo.Factura;
import uoc.facturaweb.modelo.Manejodb;
import uoc.facturaweb.modelo.Usuario;
import static uoc.facturaweb.trustedx.FirmarFactura.firmar;
/**
 *
 * @author Juanjo
 */
@WebServlet(name = "AnnadirFactura", urlPatterns = {"/AnnadirFactura"})
public class AnnadirFactura extends HttpServlet {
    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/xml");
        int idUsuario= (Integer) request.getSession().getAttribute("idUsuario");
        String num=request.getParameter("numero");
        String fecha=request.getParameter("fecha");
        Date d = null;
        try {
            d=new SimpleDateFormat("yyyy-MM-dd").parse(fecha);
        } catch (ParseException ex) {
            Logger.getLogger( AnnadirFactura.class.getName()).log(Level.SEVERE, null, ex);
        }
        String idrecepto=request.getParameter("cliente");
        int idreceptor=Integer.parseInt(idrecepto);
        Manejodb mj=new Manejodb();
        ArrayList<Entidad> conn=mj.Obtener("CONCEPTO", 0);
        ArrayList<Concepto> con=new ArrayList<Concepto>();
        for (Entidad e:conn ){
            con.add((Concepto) e);
        }
        Factura f= new Factura(idUsuario,idreceptor,num,1,d,con);
        int idfactura=f.GuardarId();
        f.id=idfactura;
        f.urlfirma="Factura-"+f.numero+".xml";
        mj.actualizarFactura(f);
        mj.actualizarConceptos(idfactura);
        Usuario u=mj.ObtenerUsuario(f.idEmisor);
        Cliente c=mj.ObtenerCliente(idreceptor);
        FileWriter writer=new FileWriter("FacturasGeneradas/Factura-"+f.numero+".xml", true);
        FileWriter out = writer;
        try {
            /* TODO output your page here. You may use following sample code. */           
            out.write("<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>");
            out.write("<fe:Facturae xmlns:fe=\"http://www.facturae.es/Facturae/2014/v3.2.1/Facturae\" xmlns:ds=\"http://www.w3.org/2000/09/xmldsig#\">");
            out.write("<FileHeader><SchemaVersion>3.2.1</SchemaVersion><Modality>I</Modality><InvoiceIssuerType>EM</InvoiceIssuerType>");
            out.write("<Batch><BatchIdentifier>FACT-"+f.getNumero()+"</BatchIdentifier><InvoicesCount>1</InvoicesCount>");            
            out.write("<TotalInvoicesAmount><TotalAmount>"+f.importeTotal()+"</TotalAmount></TotalInvoicesAmount><TotalOutstandingAmount><TotalAmount>"+f.importeTotal()+"</TotalAmount></TotalOutstandingAmount><TotalExecutableAmount><TotalAmount>"+f.importeTotal()+"</TotalAmount></TotalExecutableAmount><InvoiceCurrencyCode>EUR</InvoiceCurrencyCode></Batch></FileHeader>");
            out.write("<Parties><SellerParty><TaxIdentification><PersonTypeCode>"+u.tipoPersona+"</PersonTypeCode><ResidenceTypeCode>"+u.tipoResidencia+"</ResidenceTypeCode><TaxIdentificationNumber>"+u.idFiscal+"</TaxIdentificationNumber></TaxIdentification>");
            if (u.tipoPersona.equals("F")){
                out.write("<Individual><Name>"+u.nombre+"</Name><FirstSurname>"+u.apellido1+"</FirstSurname><SecondSurname>"+u.apellido2+"</SecondSurname><AddressInSpain><Address>"+u.direccion+"</Address><PostCode>"+u.codPostal+"</PostCode><Town>"+u.poblacion+"</Town><Province>"+u.provincia+"</Province><CountryCode>ESP</CountryCode></AddressInSpain></Individual></SellerParty>");
            }else{
                out.write("<LegalEntity><CorporateName>"+u.nombreComercial+"</CorporateName><AddressInSpain><Address>"+u.direccion+"</Address><PostCode>"+u.codPostal+"</PostCode><Town>"+u.poblacion+"</Town><Province>"+u.provincia+"</Province><CountryCode>ESP</CountryCode></AddressInSpain></LegalEntity></SellerParty>");
            }
            out.write("<BuyerParty><TaxIdentification><PersonTypeCode>"+c.tipoPersona+"</PersonTypeCode><ResidenceTypeCode>"+c.tipoResidencia+"</ResidenceTypeCode><TaxIdentificationNumber>"+c.idFiscal+"</TaxIdentificationNumber></TaxIdentification>");
            if (c.tipoPersona.equals("F")){
                out.write("<Individual><Name>"+c.nombre+"</Name><FirstSurname>"+c.apellido1+"</FirstSurname><SecondSurname>"+c.apellido2+"</SecondSurname><AddressInSpain><Address>"+c.direccion+"</Address><PostCode>"+c.codPostal+"</PostCode><Town>"+c.poblacion+"</Town><Province>"+c.provincia+"</Province><CountryCode>ESP</CountryCode></AddressInSpain></Individual></BuyerParty>");
            }else{
                out.write("<LegalEntity><CorporateName>"+c.nombreComercial+"</CorporateName><AddressInSpain><Address>"+c.direccion+"</Address><PostCode>"+c.codPostal+"</PostCode><Town>"+c.poblacion+"</Town><Province>"+c.provincia+"</Province><CountryCode>ESP</CountryCode></AddressInSpain></LegalEntity></BuyerParty>");
            }
            String fech= new SimpleDateFormat("yyyy-MM-dd").format(f.fecha);
            out.write("</Parties><Invoices><Invoice><InvoiceHeader><InvoiceNumber>"+f.numero+"</InvoiceNumber><InvoiceSeriesCode>Emit-</InvoiceSeriesCode><InvoiceDocumentType>FC</InvoiceDocumentType><InvoiceClass>OO</InvoiceClass></InvoiceHeader><InvoiceIssueData><IssueDate>"+fech+"</IssueDate><InvoiceCurrencyCode>EUR</InvoiceCurrencyCode><TaxCurrencyCode>EUR</TaxCurrencyCode><LanguageName>es</LanguageName></InvoiceIssueData>");
            for (Concepto co:f.conceptos){
                out.write("<TaxesOutputs><Tax><TaxTypeCode>01</TaxTypeCode><TaxRate>"+co.porcentaje+"</TaxRate><TaxableBase><TotalAmount>"+co.importeBruto()+"</TotalAmount></TaxableBase><TaxAmount><TotalAmount>"+co.iva()+"</TotalAmount></TaxAmount></Tax></TaxesOutputs>");
            }
            out.write("<InvoiceTotals><TotalGrossAmount>"+f.importeBruto()+"</TotalGrossAmount><TotalGeneralDiscounts>0.0</TotalGeneralDiscounts><TotalGeneralSurcharges>0.0</TotalGeneralSurcharges><TotalGrossAmountBeforeTaxes>"+f.importeBruto()+"</TotalGrossAmountBeforeTaxes><TotalTaxOutputs>"+f.ivaTotal()+"</TotalTaxOutputs><TotalTaxesWithheld>0.0</TotalTaxesWithheld><InvoiceTotal>"+f.importeTotal()+"</InvoiceTotal><TotalOutstandingAmount>"+f.importeTotal()+"</TotalOutstandingAmount><TotalExecutableAmount>"+f.importeTotal()+"</TotalExecutableAmount></InvoiceTotals><Items>");
            for (Concepto co:f.conceptos){
                out.write("<InvoiceLine><ItemDescription>"+co.descripcion+"</ItemDescription><Quantity>"+co.cantidad+"</Quantity><UnitOfMeasure>"+co.unidades+"</UnitOfMeasure><UnitPriceWithoutTax>"+co.precio+"</UnitPriceWithoutTax><TotalCost>"+co.importeBruto()+"</TotalCost><GrossAmount>"+co.importeBruto()+"</GrossAmount><TaxesOutputs><Tax><TaxTypeCode>01</TaxTypeCode><TaxRate>"+co.porcentaje+"</TaxRate><TaxableBase><TotalAmount>"+co.importeBruto()+"</TotalAmount></TaxableBase><TaxAmount><TotalAmount>"+co.iva()+"</TotalAmount></TaxAmount></Tax></TaxesOutputs></InvoiceLine>");
            }
            out.write("</Items></Invoice></Invoices>");
            out.write("</fe:Facturae> ");
        } finally {            
            out.close();
        }
        ArrayList<String> dev=firmar("FacturasGeneradas\\Factura-"+f.numero+".xml", f);
        f.documentId=dev.get(0);
        mj.actualizarFactura(f);
        request.getSession().setAttribute("idFacturault", f.documentId);
        request.getSession().setAttribute("tokenFirma", dev.get(2));
        response.sendRedirect(dev.get(1));
        mj.cerrar();
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
