
package uoc.facturaweb.controlador;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Collection;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.annotation.MultipartConfig;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.Part;
import uoc.facturaweb.modelo.FacturaRecibida;
import static uoc.facturaweb.trustedx.XmlEnvelopedSignature.verifyEnvelopedXml;
/**
 *
 * @author Juanjo
 */
@WebServlet(name = "SubirFactura", urlPatterns = {"/SubirFactura"})
@MultipartConfig(location="/")
public class SubirFactura extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        Collection<Part> parts = request.getParts();
        String rutar= new File (".").getAbsolutePath ();
        rutar=rutar.substring(0, rutar.length()-1)+"FacturasSubidas\\";
        String nombreFichero="";
        for(Part part : parts) {
                part.write(rutar+getFileName(part));                   
                nombreFichero=part.getSubmittedFileName(); 
        }
        String cadena, cadena2 = "";
        java.io.FileReader fa=new FileReader(rutar+"/"+nombreFichero);
        BufferedReader b = new BufferedReader(fa);
        byte [] xm = null;
        while((cadena = b.readLine())!=null) {
            xm=cadena.getBytes();
            cadena2=cadena2+cadena;
        }
        byte[] xm2= cadena2.getBytes();
        String fecha=request.getParameter("fecha");
        String emisor=request.getParameter("emisor");
        try (PrintWriter out = response.getWriter()) {
            /* TODO output your page here. You may use following sample code. */
            out.println("<!DOCTYPE html>");
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Factura Subida:</title>");            
            out.println("</head>");
            out.println("<body>");
            if (verifyEnvelopedXml(xm2)){
                out.println("<h1> Factura subida al servidor</h1>");
                out.println("<h3> La factura ha sido verificada</h3>");
                out.println("<h5> La factura es de: " + fecha+"--"+emisor+ "</h5>");
                out.println("<h5> La factura se encuentra en: FacturasSubidas\\"+nombreFichero+ "</h5>");
                 int idUsuario= (Integer) request.getSession().getAttribute("idUsuario");
                Date d=new SimpleDateFormat("yyyy-MM-dd").parse(fecha);
                FacturaRecibida f=new FacturaRecibida(emisor,nombreFichero,idUsuario,d);
                f.Guardar();
            }else{
                 out.println("<h3> La factura no ha sido verificada</h3>");
            }
            out.println("<p><a href='index.jsp' >Volver</a></p>");
            out.println("</body>");
            out.println("</html>");
        } catch (ParseException ex) {
            Logger.getLogger(SubirFactura.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
        public String getFileName(Part part) {
            String contentHeader = part.getHeader("content-disposition");
            String[] subHeaders = contentHeader.split(";");
            for(String current : subHeaders) {
                if(current.trim().startsWith("filename")) {
                    int pos = current.indexOf('=');
                    String fileName = current.substring(pos+1);
                    return fileName.replace("\"", "");
                }
            }
            return null;
        }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
