
package uoc.facturaweb.modelo;

import java.util.ArrayList;
import java.util.Date;

/**
 *
 * @author Juanjo
 */
public class Factura extends Entidad{
    public int idEmisor;
    public int idReceptor;
    public String numero;
    public int emitida;
    public Date fecha;
    public ArrayList<Concepto> conceptos;
    public String documentId;
    public String urlfirma;

    public double importeBruto(){
        double importe=0;
        for(Concepto con:conceptos){
            importe=importe+con.importeBruto();
        }
        return importe;
    }
    public double importeTotal(){
        double importe=0;
        for(Concepto con:conceptos){
            importe=importe+con.importeTotal();
        }
        return importe;
    }
    public double ivaTotal(){
        double importe=0;
        for(Concepto con:conceptos){
            importe=importe+con.iva();
        }
        return importe;
    }
    public double importeBruto(double porcentaje){
        //solamente suma el importe que tenga el % de iva igual a parametro pasado
        double importe=0;
        for(Concepto con:conceptos){
            if (con.getPorcentaje()==porcentaje){
                importe=importe+con.importeBruto();
            }
        }
        return importe;
    }
        public double importeTotal(double porcentaje){
        double importe=0;
        for(Concepto con:conceptos){
            if (con.getPorcentaje()==porcentaje){
                importe=importe+con.importeTotal();
            }
        }
        return importe;
    }
   public double Iva(double porcentaje){
        double importe=0;
        for(Concepto con:conceptos){
            if (con.getPorcentaje()==porcentaje){
                importe=importe+con.iva();
            }
        }
        return importe;
    }
    public Factura(int id) {
        super(id);
    }

    public Factura() {
    }

    /**
     *
     * @param idEmisor
     * @param idReceptor
     * @param numero
     * @param emitida
     * @param fecha
     * @param conceptos
     */
    public Factura(int idEmisor, int idReceptor, String numero, int emitida, Date fecha, ArrayList<Concepto> conceptos) {
        this.idEmisor = idEmisor;
        this.idReceptor = idReceptor;
        this.numero = numero;
        this.emitida = emitida;
        this.fecha = fecha;
        this.conceptos = conceptos;
    }

    public int getIdEmisor() {
        return idEmisor;
    }

    public void setIdEmisor(int idEmisor) {
        this.idEmisor = idEmisor;
    }

    public int getIdReceptor() {
        return idReceptor;
    }

    public void setIdReceptor(int idReceptor) {
        this.idReceptor = idReceptor;
    }

    public String getNumero() {
        return numero;
    }

    public void setNumero(String numero) {
        this.numero = numero;
    }

    public int getEmitida() {
        return emitida;
    }

    public void setEmitida(int emitida) {
        this.emitida = emitida;
    }

    public Date getFecha() {
        return fecha;
    }

    public void setFecha(Date fecha) {
        this.fecha = fecha;
    }

    public ArrayList<Concepto> getConceptos() {
        return conceptos;
    }

    public void setConceptos(ArrayList<Concepto> conceptos) {
        this.conceptos = conceptos;
    }
    
}
