
package uoc.facturaweb.trustedx;

import gvjava.org.json.JSONArray;
import gvjava.org.json.JSONException;
import gvjava.org.json.JSONObject;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;
import uoc.facturaweb.modelo.Factura;

/**
 *
 * @author Juanjo
 */
public class FirmarFactura {
    
    public static ArrayList<String> firmar(String ficheroURL, Factura f){
        ArrayList<String> Arr=new ArrayList<String>();
        try {
            //obtener token
            String rutarr= new File (".").getAbsolutePath ();
            String rut=rutarr.substring(0, rutarr.length()-1)+ficheroURL;
            OkHttpClient client = new OkHttpClient();
            MediaType mediaType = MediaType.parse("application/x-www-form-urlencoded");
            RequestBody body = RequestBody.create(mediaType, "grant_type=client_credentials&scope=urn%3Asafelayer%3Aeidas%3Asign%3Aprocess%3Adocument&undefined=");
            Request request = new Request.Builder()        
                    .url("https://uoc.safelayer.com:8082/trustedx-authserver/oauth/main/token")
                  .post(body)
                  .addHeader("Authorization", "Basic ZmFjdHVyYWU6ZmFjdHVyYWU=")
                  .addHeader("User-Agent", "PostmanRuntime/7.11.0")
                  .addHeader("Accept", "*/*")
                  .addHeader("Cache-Control", "no-cache")
                  .addHeader("Postman-Token", "20e174af-12a7-4ab8-9962-9a601999874c,29ba6bd7-47d7-474a-9c1a-3b8005ad7a10")
                  .addHeader("Host", "uoc.safelayer.com:8082")
                  .addHeader("content-type", "application/x-www-form-urlencoded")
                  .addHeader("accept-encoding", "gzip, deflate")
                  .addHeader("content-length", "87")
                  .addHeader("Connection", "keep-alive")
                  .addHeader("cache-control", "no-cache")
                  .build();
            Response response = client.newCall(request).execute();
            String jsondata=response.body().string();//recuperar llamada           
            JSONObject Jobject = null;                                     
            Jobject = new JSONObject(jsondata);
            String token=Jobject.getString("access_token");
            //una vez conseguido el token se procede a firmarlo
            OkHttpClient client2 = new OkHttpClient();

            MediaType mediaType2 = MediaType.parse("multipart/form-data; boundary=----WebKitFormBoundary7MA4YWxkTrZu0gW");
            RequestBody body2 = RequestBody.create(mediaType2, "------WebKitFormBoundary7MA4YWxkTrZu0gW\r\nContent-Disposition: form-data; name=\"process\"\r\n\r\n{\n  \"process_type\": \"urn:safelayer:eidas:processes:document:sign\",\n   \"signer\" : {\n        \"signature_policy_id\" : \"urn:safelayer:eidas:policies:sign:document:xml\",\n        \"parameters\": {\n            \"type\" : \"xades-epes\",\n            \"signature_target\" : {\n                \"signature_packaging\" : \"enveloped\"\n            },\n            \"policy_identifier\" : {\n                \"policy_id\" : {\n                    \"identifier\" : {\n                        \"uri\": \"urn:oid:2.16.724.1.3.1.1.2.1.9\",\n                        \"qualifier\" : \"OIDAsURN\"\n                    },\n                    \"description\" : \"Política de firma electrónica para la Administración General del Estado\"\n                },\n                \"policy_hash\" : {\n                    \"digest_algorithm_identifier\" : {\"id\" : \"sha1\"},\n                    \"digest_value\" : \"G7roucf600+f03r/o0bAOQ6WAs0=\"\n                },\n                \"policy_qualifiers\" : [\n                    {\n                        \"type\" : \"spuri\",\n                        \"uri\" : \"https://sede.060.gob.es/politica_de_firma_anexo_1.pdf\"\n\n                    }\n                ]\n            }\n        }\n    },\n  \"finish_callback_url\": \"http://localhost:8080/facturaweb/XMLFirmado\"\n}\r\n------WebKitFormBoundary7MA4YWxkTrZu0gW\r\nContent-Disposition: form-data; name=\"document\"; filename=\""+rut+"\"\r\nContent-Type: application/xml\r\n\r\n\r\n------WebKitFormBoundary7MA4YWxkTrZu0gW--");
            Request request2 = new Request.Builder()
                   .url("https://uoc.safelayer.com:8082/trustedx-resources/esignsp/v2/signer_processes")
                  .post(body2)
                  .addHeader("Authorization", "Bearer "+ token)
                  .addHeader("User-Agent", "PostmanRuntime/7.11.0")
                  .addHeader("Accept", "*/*")
                  .addHeader("Cache-Control", "no-cache")
                  .addHeader("Postman-Token", "6771cfbf-9425-4e56-a0c5-04a029b5445f,ee1488a4-337e-4e24-b13c-959306770fbb")
                  .addHeader("Host", "uoc.safelayer.com:8082")
                  .addHeader("cookie", "JSESSIONID=0F27A244135581B662D9F40AFEB7AD3A")
                  .addHeader("accept-encoding", "gzip, deflate")
                  .addHeader("content-type", "multipart/form-data; boundary=----WebKitFormBoundary7MA4YWxkTrZu0gW")
                  .addHeader("content-length", "4793")
                  .addHeader("Connection", "keep-alive")
                  .addHeader("cache-control", "no-cache")
                  .build();
            Response response2 = client2.newCall(request2).execute();
            String jsondata2=response2.body().string();//recuperar llamada           
            JSONObject Jobject2 = null; 
            Jobject2 = new JSONObject(jsondata2);
            JSONObject tasks=Jobject2.getJSONObject("tasks");              
            JSONArray pendi=tasks.getJSONArray("pending");              
            JSONObject pend=pendi.getJSONObject(0);
            String URL=pend.getString("url");
            JSONArray docss=Jobject2.getJSONArray("documents");
            JSONObject docs=docss.getJSONObject(0);
            String id=docs.getString("id");
            Arr.add(id);
            Arr.add(URL);
            Arr.add(token);          
        } catch (IOException ex) {
            Logger.getLogger(FirmarFactura.class.getName()).log(Level.SEVERE, null, ex);
        } catch (JSONException ex) {
            Logger.getLogger(FirmarFactura.class.getName()).log(Level.SEVERE, null, ex);
        }
    return Arr;
    }
   
}
