
package uoc.facturaweb.trustedx;


import com.safelayer.trustedx.client.smartwrapper.Constants;
import com.safelayer.trustedx.client.smartwrapper.SmartHeader;
import com.safelayer.trustedx.client.smartwrapper.SmartVerifyRequest;

import com.safelayer.trustedx.client.smartwrapper.SmartVerifyResponse;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.apache.axis.encoding.Base64;
/**
 *
 * @author Juanjo
 */
public class XmlEnvelopedSignature {

    
static final String TRUSTEDX_URL = "https://uoc.safelayer.com:8080/trustedx-gw/SoapGateway";
    static final String TRUSTEDX_USER="validador.facturae";
    static final String TRUSTEDX_PWD="alumnoMISTIC";
    static final String SIGNER_DN="CN=trustedx, OU=Demo, O=Trustedx, C=ES";
    static final String RESULTMAJOR_SUCCESS="urn:oasis:names:tc:dss:1.0:resultmajor:Success";
    static final String RESULTMINOR_SUCCESS="urn:oasis:";
    
    public static boolean verifyEnvelopedXml(byte[] signature){
        try {
            SmartVerifyRequest vReq= new SmartVerifyRequest(TRUSTEDX_URL);
            vReq.setProfile(Constants.Profile.XADES );
            vReq.setInputXmlBase64(Base64.encode(signature));
            vReq.setAddSignatureForm(true);
           SmartHeader header =new SmartHeader();
           header.setUsername(TRUSTEDX_USER);
           header.setPassword(TRUSTEDX_PWD);
           vReq.setHeader(header);
           SmartVerifyResponse vResp=vReq.send();
           //SVerificando firma 
           if (RESULTMAJOR_SUCCESS.equals(vResp.getResultMajor())){
               //"Firma Verificada"            
               return true;
           }
           else{   
                   return false;
                       }
        } catch (Exception ex) {            
            Logger.getLogger(XmlEnvelopedSignature.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }
    }
}
